<template>
  <div class="ele-body">
    <el-card shadow="never">
      <!-- 搜索表单 -->
      <user-search @search="reload" />
      <!-- 数据表格 -->
      <ele-pro-table ref="table" :columns="columns" :datasource="datasource" :selection.sync="selection" row-key="id">
        <!-- 表头工具栏 -->
        <template v-slot:toolbar>
          <el-button size="small" type="primary" icon="el-icon-plus" class="ele-btn-icon"
            @click="openEdit(null)">新增</el-button>

          <el-button size="small" type="primary" icon="el-icon-refresh-left" class="ele-btn-icon" @click='refreshData'
            :loading="loading">刷新</el-button>
        </template>

        <!-- 状态列 -->
        <template v-slot:status="{ row }">
          {{ checkStatus(row) }}
        </template>

        <!-- 操作列 -->
        <template v-slot:action="{ row }">
          <el-link type="primary" :underline="false" icon="el-icon-edit" @click="openEdit(row)">
            修改
          </el-link>
          <el-link type="primary" :underline="false" icon="el-icon-setting" @click="openSetting(row)">
            配置工序
          </el-link>

          <el-popconfirm v-if="row.status != 1" class="ele-action" title="确定要删除当前工序吗？" @confirm="remove(row)">
            <template v-slot:reference>
              <el-link type="danger" :underline="false" icon="el-icon-delete">
                删除
              </el-link>
            </template>
          </el-popconfirm>


          <el-link type="primary" :underline="false" icon="el-icon-document" @click="openHistory(row)">
            查看历史版本
          </el-link>

        </template>
      </ele-pro-table>
    </el-card>
    <!-- 编辑弹窗 -->
    <user-edit :visible.sync="showEdit" :data="current" @done="reload" ref="userEdit" />
    <!-- 自身工序弹窗 -->
    <user-taskinstance :visible.sync="showTaskinstance" :data="current" ref="userTaskinstance" />

    <!-- 历史版本弹框 -->
    <historyModal  ref="historyRefs"></historyModal>


  </div>
</template>

<script>
import UserSearch from './components/user-search.vue';
import UserEdit from './components/user-edit.vue';
import UserTaskinstance from './components/user-taskinstance.vue';
import historyModal from './components/historyModal.vue'
import route from '@/api/technology/route';
export default {
  name: 'technologyRoute',
  components: {
    UserSearch,
    UserEdit,
    UserTaskinstance,
    historyModal
  },
  data() {
    return {
      // 表格列配置
      columns: [
        // {
        //   columnKey: 'selection',
        //   type: 'selection',
        //   width: 45,
        //   align: 'center',
        //   fixed: 'left'
        // },

        {
          prop: 'code',
          label: '工艺路线组编码',
          // sortable: 'custom',
          showOverflowTooltip: true,
          align: 'center',

          minWidth: 110
        },
        {
          prop: 'name',
          label: '工艺路线名称',
          showOverflowTooltip: true,
          align: 'center',
          minWidth: 110
        },
        {
          align: 'center',
          prop: 'categoryCode',
          label: '产品编码',
          showOverflowTooltip: true,
          minWidth: 110
        },
        {
          prop: 'categoryName',
          label: '产品名称',
          align: 'center',
          showOverflowTooltip: true,
          minWidth: 110
        },
        {
          prop: 'version',
          label: '工艺路线版本',
          align: 'center',
          showOverflowTooltip: true,
          minWidth: 110
        },
        {
          prop: 'status',
          label: '状态',
          align: 'center',
          slot: 'status',
          showOverflowTooltip: true,
          minWidth: 110
        },

        {
          columnKey: 'action',
          label: '操作',
          width: 220,
          align: 'left',
          resizable: false,
          slot: 'action',

        }
      ],
      showTaskinstance: false,
      // 表格选中数据
      selection: [],
      // 当前编辑数据
      current: null,
      // 是否显示编辑弹窗
      showEdit: false,

      statusList: [
        { label: '草稿', value: -1 },
        { label: '失效', value: 0 },
        { label: '生效', value: 1 }
      ],
      loading: false
    };
  },
  methods: {
    /* 表格数据源 */
    async datasource({ page, limit, where, order }) {
      const res = await route.list({
        ...where,
        ...order,
        pageNum: page,
        size: limit
      });
      return res;
    },
    openSetting(row) {
      this.current = row;
      this.showTaskinstance = true; // 显示编辑弹窗 true/false 不显示弹窗 true/false 不显示
    },
    checkStatus(row) {
      let obj = this.statusList.find((it) => it.value == row.status);
      return obj.label;
    },

    /* 刷新表格 */
    reload(where) {
      this.$refs.table.reload({ page: 1, where: where });
    },
    /* 打开编辑弹窗 */
    openEdit(row) {
      this.current = row;
      this.showEdit = true;
      this.$refs.userEdit.$refs.form &&
        this.$refs.userEdit.$refs.form.clearValidate();
    },
   /* 打开历史版本 */
   openHistory(row) {
     this.$refs.historyRefs.open(row)
   },
    /* 删除 */
    remove(row) {
      const loading = this.$loading({ lock: true });

      route
        .delete(row.id)
        .then((msg) => {
          loading.close();
          this.$message.success('删除' + msg);
          this.reload();
        })
        .catch((e) => {
          loading.close();
          // this.$message.error(e.message);
        });
    },
    /* 批量删除 */
    removeBatch() {
      if (!this.selection.length) {
        this.$message.error('请至少选择一条数据');
        return;
      }
      this.$confirm('确定要删除选中的工序吗?', '提示', {
        type: 'warning'
      })
        .then(() => {
          const loading = this.$loading({ lock: true });
          producetask
            .delete(this.selection.map((d) => d.id))
            .then((msg) => {
              loading.close();
              this.$message.success('删除' + msg);
              this.reload();
            })
            .catch((e) => {
              loading.close();
              // this.$message.error(e.message);
            });
        })
        .catch(() => { });
    },

    // 刷新数据
    refreshData() {
      this.loading = true;
      route.syncRouting().then(res => {
        if (res == '0') {
          this.loading = false;
          this.$message.success('数据刷新成功！')
          this.reload()
        }
      })
        .catch((e) => {
          this.loading = false;
        });
    }

  }
};
</script>
